
function PersonasRotatorStartup(){}
PersonasRotatorStartup.prototype={
	QueryInterface: function(aIID) {
		if(!aIID.equals(COIN.nsISupports) && !aIID.equals(COIN.nsIObserver)) throw CORE.NS_ERROR_NO_INTERFACE;
		return this;
	},
	get wrappedJSObject( ) { return(this); },
	PersonaService:null,
	timer:Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),
	errortimer:Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),
	initializeTimer:function(passedTime,extrachangeisrequested){

		var personasrotatorprefinstance=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

		// 1* try to change the category
		//should we use math.random. personas warning search

		var PersonasRotatorRotationCategory=personasrotatorprefinstance.getCharPref("extensions.personasrotator.rotationcategory");

			
		if(PersonasRotatorRotationCategory=="All"){
		
			personasrotatorprefinstance.setCharPref("extensions.personas.category",PersonaService.personas.categories[parseInt(Math.random()*(PersonaService.personas.categories.length-1))].name);

		}
		
		else if (PersonasRotatorRotationCategory=="My Favorites") {/* foobar */}
		
		else {

			personasrotatorprefinstance.setCharPref("extensions.personas.category",PersonasRotatorRotationCategory);
		
		}
		
		// 2* change the rotationInterval
		
		//need a pref
		var PersonasRotatorInterval=personasrotatorprefinstance.getIntPref("extensions.personasrotator.rotationinterval");

		personasrotatorprefinstance.setIntPref("extensions.personas.rotationInterval",PersonasRotatorInterval);

		var rotationenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled");
				
		// 3* change the selected
				
		//assure it -- what happens random again beocmes random. also this makes double rotatepersona request
		if(rotationenabled) {
	
			if(PersonasRotatorRotationCategory!="My Favorites" && personasrotatorprefinstance.getCharPref("extensions.personas.selected")!="random"){
					
				personasrotatorprefinstance.setCharPref("extensions.personas.selected","random");
			
			}
			
			else if (PersonasRotatorRotationCategory=="My Favorites" && personasrotatorprefinstance.getCharPref("extensions.personas.selected")!="randomFavorite") {
		
				personasrotatorprefinstance.setCharPref("extensions.personas.selected","randomFavorite");
			
			}				
		
		}

		this.PersonaService._rotationTimer.cancel();

		let selectedMode = this.PersonaService.selected;

		if (rotationenabled && (selectedMode == "random" || selectedMode == "randomFavorite")) {
		 
			let interval = PersonasRotatorInterval * 1000;
			
			let that = this.PersonaService;
			
			this.PersonaService._rotationTimer.initWithCallback(
				
				{ 
				
				notify: function(aTimer) { 
					
					var personasrotatorprefinstance=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

					var PersonasRotatorRotationCategory=personasrotatorprefinstance.getCharPref("extensions.personasrotator.rotationcategory");
							
					if(PersonasRotatorRotationCategory=="All"){

						personasrotatorprefinstance.setCharPref("extensions.personas.category",that.personas.categories[parseInt(Math.random()*(that.personas.categories.length-1))].name);
				
					}
			
					that._rotatePersona(); 
				
				} 
				
			},interval, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
				
			//we donot need this. service.js init is already firing one.
			if(extrachangeisrequested) this.PersonaService._rotatePersona();
				
		}		
		
	},
	cancelTimer:function(){
		PersonaService._rotationTimer.cancel();
	},
	askModule:function(){

		// Define Components as var here as they are already defined for Firefox. See Bug 484062 for details.
		  if (typeof Cc == "undefined")
			var Cc = Components.classes;
		  if (typeof Ci == "undefined")
			var Ci = Components.interfaces;
		  if (typeof Cr == "undefined")
			var Cr = Components.results;
		  if (typeof Cu == "undefined")
			var Cu = Components.utils;

		// It's OK to import the service module into the global namespace because its
		// exported symbols all contain the word "persona" (f.e. PersonaService).
		
		try{
		
			Cu.import("resource://personas/modules/service.js");
		
			let that = PersonaService;
			this.PersonaService = that;	

			this.askActivation();
			
		}
		catch(err){

			let that=this;
			
			this.errortimer.initWithCallback(
				
				{ 
				
				notify: function(aTimer) { 

					that.askModule();
									
				} 
				
			},500, Components.interfaces.nsITimer.TYPE_ONE_SHOT);	
			
		}
		
	},
	registerPrefObserver:function(){
		
		var personasrotatorlogalertenabled;
		
		var personasrotatorprefinstance;

		personasrotatorprefinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		
		var rotationenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled");
	
		var PersonasRotatorPrefObserver =
		{
		  register: function()
		  {

			var prefService = Components.classes["@mozilla.org/preferences-service;1"]
										.getService(Components.interfaces.nsIPrefService);

			this._branch = prefService.getBranch("extensions.personas");

			this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);

			this._branch.addObserver("", this, false);
			
		  },

		  unregister: function()
		  {
		  
			if(!this._branch) {return;}
			this._branch.removeObserver("", this);
			
		  },

		  observe: function(aSubject, aTopic, aData)
		  {
		  
			if(aTopic != "nsPref:changed") {return;}	
			
			if(aData=="rotator.logalertenabled"){

				personasrotatorlogalertenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.logalertenabled");
				
				if(personasrotatorlogalertenabled){

					Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).registerListener(PersonasRotatorErrorObserver);
				
				}
				
				else {
				
					Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).unregisterListener(PersonasRotatorErrorObserver);
				
				}

			}
		
			if(aData==".selected"){
	
	
			var personasrotatorprefinstance=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			
			
			var personasselected = personasrotatorprefinstance.getCharPref("extensions.personas.selected");
		
			/*
		
			var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
									.getService(Components.interfaces.nsIPromptService);
									
			prompt.alert(null, "Browser Backgrounds",personasselected);	

			*/
		
			if(personasselected=="randomFavorite") {
				
				/*
							
				var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
									
				prompt.alert(null, "Browser Backgrounds",personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled"));
				
				*/
				
				//get the randomFavorite collection request and apply it to the personas rotator. initialise will reapply to the personas.category anyway
				
				personasrotatorprefinstance.setCharPref("extensions.personasrotator.rotationcategory","My Favorites");

				if(personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled")) return;
				
				personasrotatorprefinstance.setBoolPref("extensions.personasrotator.rotationenabled",true);
				
				var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				
				var enumerator = wm.getEnumerator("navigator:browser");
				
				var win = null;
				
				var winarray=[];
				
				while (enumerator.hasMoreElements()) {
				
					win = enumerator.getNext();
					
					break;
					
				}
				
				win.PersonasRotator.enableRotation();			
			
			}

			else if(personasselected=="random") {
				
				/*
						
				var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
									
				prompt.alert(null, "Browser Backgrounds",personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled"));
				
				*/
				
				//get the random collection request and apply it to the personas rotator. initialise will reapply to the personas.category anyway
				
				personasrotatorprefinstance.setCharPref("extensions.personasrotator.rotationcategory",personasrotatorprefinstance.getCharPref("extensions.personas.category"));

				if(personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled")) return;
				
				personasrotatorprefinstance.setBoolPref("extensions.personasrotator.rotationenabled",true);
				
				var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				
				var enumerator = wm.getEnumerator("navigator:browser");
				
				var win = null;
				
				var winarray=[];
				
				while (enumerator.hasMoreElements()) {
				
					win = enumerator.getNext();
					
					break;
					
				}
				
				win.PersonasRotator.enableRotation();
			
			}
				
			
			else {
					
				if(!personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled")) return;
				
				personasrotatorprefinstance.setBoolPref("extensions.personasrotator.rotationenabled",false);
				
				/*	
				
				var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
										.getService(Components.interfaces.nsIPromptService);
										
				prompt.alert(null, "Browser Backgrounds",personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled"));		

				*/
				
				var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
				
				var enumerator = wm.getEnumerator("navigator:browser");
				
				var win = null;
				
				var winarray=[];
				
				while (enumerator.hasMoreElements()) {
				
					win = enumerator.getNext();
					
					break;
					
				}
				
				win.PersonasRotator.disableRotation();
			
			}			

			}
			
		  }
		  
		}

		PersonasRotatorPrefObserver.register(); 
	
	},
	
	askActivation:function(){

		var personasrotatorlogalertenabled;
		var personasrotatorprefinstance;

		personasrotatorprefinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		
		var rotationenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled");
			
		var firstinstallalogrithmevaluated=personasrotatorprefinstance.getBoolPref("extensions.personasrotator.firstinstallalogrithmevaluated");
		var addoninstalled=personasrotatorprefinstance.getBoolPref("extensions.personasrotator.installed");
		
		if(!addoninstalled  && !firstinstallalogrithmevaluated) {
			
			// && this.PersonaService.isUserSignedIn at component level sign in value is somehow retireved false. look into
			if (this.PersonaService.favorites && this.PersonaService.favorites.length > 0) {personasrotatorprefinstance.setCharPref("extensions.personasrotator.rotationcategory","My Favorites");}
			else personasrotatorprefinstance.setCharPref("extensions.personasrotator.rotationcategory","All");
			
			personasrotatorprefinstance.setBoolPref("extensions.personasrotator.firstinstallalogrithmevaluated",true);
		
		}
		
		var personasrotatorrotationinterval = personasrotatorprefinstance.getIntPref("extensions.personasrotator.rotationinterval");

		this.cancelTimer();
		
		if (rotationenabled) this.initializeTimer(personasrotatorrotationinterval,false);//false because init is requesting
	 	
		this.registerPrefObserver();
		
	},
	classID: Components.ID("{e3e10a35-3976-4df9-b53d-f72545c808ac}"),
	classDescription: "PersonasRotator Startup",  
	contractID: "@personasrotator/startup;1",
	observe: function(aSubject,aTopic,aData) {
	switch(aTopic) {
	  case "xpcom-startup":
	   
		var observerService = COCL["@mozilla.org/observer-service;1"].getService(COIN.nsIObserverService);
		observerService.addObserver(this,"quit-application",false);        
		observerService.addObserver(this,"profile-after-change",false);
		observerService.addObserver(this,"quit-application-requested",false);
		
		//ubuntu css
		var sss = Components.classes['@mozilla.org/content/style-sheet-service;1'].getService(Components.interfaces.nsIStyleSheetService);
		var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var xulRuntime = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime);
		if (true) {
			var css = "@namespace url(http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul);textbox.edit-description-textbox{height:95px !important;}";
			var uri = ios.newURI("data:text/css," + css, null, null);
			if (!sss.sheetRegistered(uri, sss.USER_SHEET)) {
				sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
			}		
		}
		
		//upload form css
		var uploadformcss = "@namespace url(http://www.w3.org/1999/xhtml);@-moz-document url(chrome://personasrotator/content/wr.html) {/*reset css*/html,body{margin:0;padding:0;} p, h1, form, button {border:0 none;margin:0;padding:0;}/*padding 1px css hack*/#paddingtopdiv{padding-top: 1px;}/*style form*/#personasrotatoruploadform{padding:14px;font-size:12px;width:400px;font-family:'Lucida Grande','Lucida Sans Unicode',Verdana,Arial,Helvetica,sans-serif;margin:0 auto 0 auto;background-color:#f0fbeb;border:2px solid #C8F2B7;}#personafile{display:none;}/*span related*/#personasrotatoruploadform span{color:black;}#closeanchor{float:right;}#closeanchor:hover {cursor:pointer;text-decoration:underline;}#personasrotatoruploadform .tip{text-align:right;width:140px;display:block;font-size:11px;color:#666666;font-weight:normal;}/*main heading related*/#uploadheading{display:block;margin-bottom:8px;font-size:14px;font-weight:bold;}#personasrotatoruploadform p{padding-bottom:10px;font-size:11px;margin-bottom:20px;border-bottom:solid 1px #c8f2b7;color:#666666;}/*field label related*/#personasrotatoruploadform label{float:left;display:block;text-align:right;width:140px;font-weight:bold;}/*form input related*/#personasrotatoruploadform input,#personasrotatoruploadform  textarea {-moz-appearance:none !important;float:left;margin:2px 0 20px 10px;padding:4px 2px;border:solid 1px #b8dea8;width:200px;font-size:12px;}/*form button related*/#personasrotatoruploadform button{-moz-appearance:none !important;color:#FFFFFF;cursor:pointer;clear:both;margin-left:150px;font-weight:bold;text-align:center;width:125px;height:31px;background-color:#000000;line-height:31px;font-size:11px;}/*styles fot tooltip divs*/.tooltipdivs{border: 1px solid black;padding: 6px; background-color: lightyellow; position: absolute; top: 25px; left: 250px; max-width: 284px; font-family: Verdana,'Lucida Grande','Lucida Sans Unicode',Arial,Helvetica,sans-serif; font-size: 11px; display: none;}/*sytles for tooltip icons*/.tooltipicons{vertical-align: middle;cursor:pointer; margin-left: 5px; float: left; margin-top: 6px; text-indent: -9999px; display: block; height: 16px; width: 16px; background-image: url('chrome://personasrotator/skin/uploadtooltipicon.png');}}";
		var uploadformuri = ios.newURI("data:text/css," + uploadformcss, null, null);
		if (!sss.sheetRegistered(uploadformuri, sss.USER_SHEET)) {
			sss.loadAndRegisterSheet(uploadformuri, sss.USER_SHEET);
		}
	
		break;
	  case "profile-after-change":

		this.askModule();
			
		var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
		file.append("personasrotator");
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		if (!file.exists()) {
		/*	
			var DirectoryToCopy = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
			DirectoryToCopy.append("extensions");
			DirectoryToCopy.append("{6e73f6b7-b9ab-44b8-b744-6393e3c2e351}");
			DirectoryToCopy.append("chrome");
			DirectoryToCopy.append("content");
			DirectoryToCopy.append("personasrotator");
			var DirectoryToPasteIn=Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
			DirectoryToCopy.copyTo(DirectoryToPasteIn,"personasrotator");
		*/
		}
		
		var personasrotatorlogalertenabled;
		var personasrotatorprefinstance;

		personasrotatorprefinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		
		var rotationenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.rotationenabled");
			
		var sss = Components.classes['@mozilla.org/content/style-sheet-service;1'].getService(Components.interfaces.nsIStyleSheetService);
		var ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
		var css = "@namespace url(http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul);#personasrotator-"+((rotationenabled)? "enable" : "disable" )+"rotation{display:none !important;}";
		var uri = ios.newURI("data:text/css," + css, null, null);
		if (!sss.sheetRegistered(uri, sss.USER_SHEET)) {
			sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
		}
		
		var PersonasRotatorErrorObserver = {

			observe : function (e) {
			  
				try {

					var scriptError = e.QueryInterface(Components.interfaces.nsIScriptError);
				
					if(scriptError.sourceName.search(/personasrotator/i)!=-1||scriptError.errorMessage.search(/personasrotator/i)!=-1){	

						var promptString="category="+scriptError.category+"\n"
						+"columnNumber="+scriptError.columnNumber+"\n"
						+"errorMessage="+scriptError.errorMessage+"\n"
						+"flags="+scriptError.flags+"\n"
						+"lineNumber="+scriptError.lineNumber+"\n"
						+"sourceLine="+scriptError.sourceLine+"\n"
						+"sourceName="+scriptError.sourceName+"\n";
						
						var prompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
											.getService(Components.interfaces.nsIPromptService);
											
						prompt.alert(null, "Script Error",promptString);
						
					}
				
				} 
			  
				catch(er) {
			  
					//foobar
			  
				}

		   } 

		}

		
		
		personasrotatorprefinstance = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		personasrotatorlogalertenabled = personasrotatorprefinstance.getBoolPref("extensions.personasrotator.logalertenabled");
		
		if(personasrotatorlogalertenabled){

			Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).registerListener(PersonasRotatorErrorObserver);
		
		}				
		 
	   break;
	  case "quit-application":
		
		break;
	  case "quit-application-requested":

		if(aData=="restart"){
				
			var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
			
			var enumerator = wm.getEnumerator("navigator:browser");
			
			var win = null;
			
			var winarray=[];
			
			while (enumerator.hasMoreElements()) {
			
				win = enumerator.getNext();
				
				winarray.push(win.PersonasRotator.currentarrayindex);
				
			}
			
			win.PersonasRotatorFileIO.write(win.PersonasRotator.getChromeFile("config.abc"),winarray,'w',"UTF-8"); 
		
		}	
		
		break;		
	  default:
		throw Components.Exception("Unknown topic: "+aTopic);
	}
	},
};
var objects=[PersonasRotatorStartup];
const COIN=Components.interfaces;  
const CORE=Components.results;
const COCL=Components.classes;
const PersonasRotatorOBSERVERNAME="PersonasRotatorStartup";
function FactHolder(aObjc){
  this.contractID=aObjc.prototype.contractID;
  this.className=aObjc.prototype.classDescription;
  this.CID=aObjc.prototype.classID;
  this.factory={
    createInstance:function(aOuter,aIID){
      if(aOuter) {throw CORE.NS_ERROR_NO_AGGREGATION;}
      return (new this.constructor).QueryInterface(aIID);
    }
  };
  this.factory.constructor=aObjc;
}
function NSGetModule(compMgr,flSpec){
  for(var i in objects) {personasrotatorModule._objects[i]=new FactHolder(objects[i]);}
  return personasrotatorModule;
}

var personasrotatorModule={
  _objects:{},
  canUnload:function(aComMan){
    return true;
  },
  getClassObject:function(aComMan,aCID,aIID) {
    if (!aIID.equals(COIN.nsIFactory)) throw CORE.NS_ERROR_NOT_IMPLEMENTED;
    for (var keyo in this._objects) {
      if (aCID.equals(this._objects[keyo].CID))
        return this._objects[keyo].factory;
    }
    throw CORE.NS_ERROR_NO_INTERFACE;
  },	  
  unregisterSelf:function(aCompMgr,aFlSpec,aLoc){
    var categoryManager=COCL["@mozilla.org/categorymanager;1"].getService(COIN.nsICategoryManager);
    categoryManager.deleteCategoryEntry("xpcom-startup",PersonasRotatorOBSERVERNAME,true);
    aComMan.QueryInterface(COIN.nsIComponentRegistrar);
    for (var keyo in this._objects) {
      var objc=this._objects[keyo];
      aComMan.unregisterFactoryLocation(objc.CID,aFlSpec);
    }
  },
  registerSelf:function(aComMan,aFlSpec,aLoc,aType){
    aComMan.QueryInterface(COIN.nsIComponentRegistrar);
    for (var keyo in this._objects){
      var objc=this._objects[keyo];
      aComMan.registerFactoryLocation(objc.CID,objc.className,objc.contractID,aFlSpec,aLoc,aType);
    }
    var categoryManager=COCL["@mozilla.org/categorymanager;1"].getService(COIN.nsICategoryManager);
    categoryManager.addCategoryEntry("xpcom-startup",PersonasRotatorOBSERVERNAME,PersonasRotatorStartup.prototype.contractID,true,true);
    categoryManager.addCategoryEntry("xpcom-shutdown", PersonasRotatorOBSERVERNAME,PersonasRotatorStartup.prototype.contractID,true,true);
  },	   
};
